package cpcns.danganzhengli.ftpconfig.controller;

package .tmp;

import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganzhengli.ftpconfig.model.DFTPConfig;
import cpcns.danganzhengli.ftpconfig.service.IDFTPConfigService;
import cpcns.utils.CommStatic;
import cpcns.utils.FtpUtil;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/dFtpConfig"})
public class DFTPConfigController extends commonController {
  @Autowired
  private IDFTPConfigService dFtpConfigService;
  
  @Autowired
  private ICommonService commonService;
  
  @RequestMapping({"/query.do"})
  public String query(HttpServletRequest request) throws Exception {
    StringBuffer sql = new StringBuffer("select count(hangBiaoShi) from T_FTPCONFIG where zhuangTai=1");
    List list = this.dFtpConfigService.selectSql(sql.toString());
    String total = String.valueOf(list.get(0));
    request.setAttribute("total", total);
    return "ftpconfig/ftpConfig_list";
  }
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
    try {
      Enumeration<?> rnames = getRequest().getParameterNames();
      JSONObject jsonObject = new JSONObject();
      for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
        String thisName = er.nextElement().toString();
        String thisValue = getRequest().getParameter(thisName);
        jsonObject.put(thisName, thisValue);
      } 
      StringBuffer sqlWhere = new StringBuffer();
      Iterator<String> iterator = jsonObject.keys();
      StringBuffer sqlSearch = new StringBuffer();
      sqlSearch.append(" 1=1 ");
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && 
          !"server".equals(key) && !"table".equals(key) && !"orderBy".equals(key) && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key)) {
          if (!key.contains("like")) {
            sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value.trim() + "'");
            continue;
          } 
          key = key.substring(0, key.indexOf("like"));
          sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
        } 
      } 
      sqlWhere.append(" and zhuangTai not in (3,4)");
      if (sqlWhere.length() > 0)
        sqlSearch.append(sqlWhere.toString()); 
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      model.addAttribute("page", page);
      model.addAttribute("rows", rows);
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      StringBuffer sql = new StringBuffer("select hangBiaoShi,zhuangTai,quanZongHao,yongHuMing,yongHuMiMa,muLu,duanKou,fuWuQi,yingSheIP,menLei,zongKongJian,yiYongKongJian,qiYongRiQi,qiYongRen,zhuangTai caoZuo from T_FTPCONFIG where ");
      PagerVO pagevo = this.dFtpConfigService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "quanZongHao,menLei"), "T_FTPCONFIG");
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
      jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("QUANZONGHAO", "quanZongHao")
        .replaceAll("YONGHUMING", "yongHuMing").replaceAll("YOGHUMIMA", "yongHuMiMa").replaceAll("MULU", "muLu").replaceAll("DUANKOU", "duanKou")
        .replaceAll("FUWUQI", "fuWuQi").replaceAll("YINGSHEIP", "yingSheIP").replaceAll("MENLEI", "menLei").replaceAll("ZONGKONGJIAN", "zongKongJian")
        .replaceAll("YIYONGKONGJIAN", "yiYongKongJian").replaceAll("QIYONGRIQI", "qiYongRiQi").replaceAll("QIYONGREN", "qiYongRen").replaceAll("CAOZUO", "caoZuo");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/toAdd.do"})
  public String toAdd(HttpServletRequest request, Model model) throws Exception {
    return "ftpconfig/ftpConfig_edit";
  }
  
  @RequestMapping({"/save.do"})
  @ResponseBody
  public void save(HttpServletRequest request, HttpServletResponse response) throws Exception {
    ResultMessage rm = new ResultMessage();
    String info = "";
    String rizhiInfo = "修改";
    String menLei = getRequest().getParameter("menLei");
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    DFTPConfig t = (DFTPConfig)JsonWithJacksonUtils.getInstance().json2Obj(jsonObject.toString(), DFTPConfig.class);
    if (t.getHangBiaoShi() == null || t.getHangBiaoShi().intValue() < 0) {
      String quanZongHao = t.getQuanZongHao();
      StringBuffer sql = new StringBuffer("select  hangBiaoShi from T_FTPCONFIG  where 1=1 and quanZongHao='" + quanZongHao + "'");
      List list = new ArrayList();
      list = this.dFtpConfigService.getListSQL(sql.toString());
      if (list.size() > 0) {
        t.setZhuangTai(Integer.valueOf(0));
      } else {
        t.setZhuangTai(Integer.valueOf(1));
      } 
      t.setHangBiaoShi(Integer.valueOf(this.dFtpConfigService.getPk("T_FTPCONFIG")));
    } 
    try {
      FtpUtil ftpUtil = new FtpUtil();
      Boolean state = Boolean.valueOf(true);
      if (state.booleanValue()) {
        this.dFtpConfigService.saveOrUpdate(t);
        rm.setSuccess(true);
        info = "保存成功！";
      } else {
        rm.setSuccess(false);
        info = "保存失败！请检查ftp信息是否填写正确";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      info = "保存失败！";
      rm.setSuccess(false);
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response) throws ParseException {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String keyWordResult = request.getParameter("keyWordResult");
    String menLei = getRequest().getParameter("menLei");
    String formatDate = "";
    DFTPConfig dftp = new DFTPConfig();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      dftp = (DFTPConfig)this.dFtpConfigService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      getRequest().setAttribute("keyWordResult", keyWordResult);
      try {
        SimpleDateFormat dateFormatter = new SimpleDateFormat("yyyy-MM-dd");
        formatDate = dateFormatter.format(dftp.getQiYongRiQi());
      } catch (Exception e) {
        formatDate = "";
      } 
    } 
    getRequest().setAttribute("DFTP", dftp);
    getRequest().setAttribute("keyWordResult", keyWordResult);
    getRequest().setAttribute("formatDate", formatDate);
    return "ftpconfig/ftpConfig_edit";
  }
  
  @RequestMapping({"/delete.do"})
  @ResponseBody
  public void remove(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      String info = "";
      try {
        StringBuffer bf = new StringBuffer("delete T_FTPCONFIG where hangBiaoShi=" + hangBiaoShi);
        this.dFtpConfigService.deletSQL(bf.toString());
        info = "删除成功！";
        rm.setSuccess(true);
      } catch (Exception e) {
        e.printStackTrace();
        rm.setSuccess(false);
        info = "删除失败！";
      } 
      rm.setInfo(info);
      rm.addResultMessage("data", "[{}]");
      responseWriter(response, rm.toString());
    } 
    rm.setSuccess(false);
    rm.setInfo("删除失败，选择的记录无效！");
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/updateZhuangTai.do"})
  @ResponseBody
  public void updateZhuangTai(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      String info = "";
      DFTPConfig dftp = (DFTPConfig)this.dFtpConfigService.getById(Integer.valueOf(hangBiaoShi));
      String quanZongHao = dftp.getQuanZongHao();
      StringBuffer sq = new StringBuffer("select menLei from T_FTPCONFIG where hangBiaoShi=" + hangBiaoShi);
      List<String> ls = this.dFtpConfigService.getList(sq.toString());
      if (StringUtils.isNotBlank(quanZongHao)) {
        try {
          StringBuffer sql = new StringBuffer("update T_FTPCONFIG set zhuangTai = 0 where hangBiaoShi in( ");
          StringBuffer sqlSer = new StringBuffer("update T_FTPCONFIG set zhuangTai =1  where hangBiaoShi =" + hangBiaoShi);
          StringBuffer sqlWhere = new StringBuffer("select hangBiaoShi from T_FTPCONFIG  where 1=1 and quanZongHao='" + quanZongHao + "' and hangBiaoShi not in(" + hangBiaoShi + ")");
          if (ls.size() > 0)
            sqlWhere = new StringBuffer("select hangBiaoShi from T_FTPCONFIG  where 1=1 and quanZongHao='" + quanZongHao + "' and hangBiaoShi not in(" + hangBiaoShi + ") and menLei='" + ls.get(0) + "'"); 
          List list = new ArrayList();
          list = this.dFtpConfigService.getList(sqlWhere.toString());
          if (list.size() > 0) {
            sql.append(sqlWhere).append(" ) ");
            this.dFtpConfigService.update(sql.toString());
          } 
          this.dFtpConfigService.update(sqlSer.toString());
          info = "启用成功！";
          rm.setSuccess(true);
        } catch (Exception e) {
          e.printStackTrace();
          rm.setSuccess(false);
          info = "启用失败！";
        } 
        rm.setInfo(info);
        rm.addResultMessage("data", "[{}]");
        responseWriter(response, rm.toString());
      } 
    } 
    rm.setSuccess(false);
    rm.setInfo("启用失败，选择的记录无效！");
    responseWriter(response, rm.toString());
  }
}
